import sys

from ardi.driver import drivercore,driverbase

from pymodbus.client.sync import ModbusTcpClient as ModbusClient
from pymodbus.pdu import ExceptionResponse as ExceptionResponse

try:    
    from pymodbus.payload import PayloadDecoder as BinaryPayloadDecoder
except:
    from pymodbus.payload import BinaryPayloadDecoder

class ardimbtcpdriver:
    def __init__(self):
        self.connected = False
        self.polling = True
    
    def SetAddress(self, addr):
        self.connected = False
        bits = addr.split(":")
        self.ip = bits[0]
        self.port = int(bits[1])
        self.unit = int(bits[2])
    
    def Connect(self):
        #self.SetAddress(addr)
        self.connected = False
        self.client = ModbusClient(self.ip, port=self.port)
        try:
            success = self.client.connect()
            if success == False:
                return False
            self.connected = True
            return True
        except:
           return False
    
    def Disconnect(self):
        self.connected = False
        self.client.close()
        
    def Poll(self):
        for item in self.core.pointlist:
            bits = item.address.split('|')
            mode = 0
            address = 0
            
            if len(bits) == 1:
                address = int(bits[0])
            else:
                address = int(bits[0])
                mode = int(bits[1])
                
            if address < 100000:
                rr = self.client.read_coils(address,1)
                self.core.UpdateData(item.code,rr.bits[0])
                continue
            
            if address < 200000:
                rr = self.client.read_discrete_inputs(address-100000,1)
                self.core.UpdateData(item.code,rr.bits[0])
                continue
            
            ln = 1
            if (mode == 1):
                ln = 2
            elif (mode == 2):
                ln = 4
            elif (mode == 3):
                ln = int(bits[2])
            
            if address < 400000:
                rr = self.client.read_input_registers(address-300000,ln)
            else:
				rr = self.client.read_holding_registers(address-400000,ln)

            if type(rr) is ExceptionResponse:
                print 'Error Reading ' + str(address)
                
                return

            if mode == 0:
                print 'Reading ' + str(address)				
                print str(rr.registers[0])
                self.core.UpdateData(item.code,rr.registers[0])
                return
            
            en = '<';
            decoder = BinaryPayloadDecoder.fromRegisters(rr.registers,endian=en)
            
            if mode == 1:
                val = decoder.decode_32bit_int()				
                self.core.UpdateData(item.code,val)
            if mode == 10:
                val = decoder.decode_32bit_float()
                self.core.UpdateData(item.code,val)
                return
            if mode == 11:
                val = decoder.decode_64bit_float()
                self.core.UpdateData(item.code,val)
            if mode == 20:
                val = decoder.decode_string(int(bits[2]))
                self.core.UpdateData(item.code,val)
				           
            
    def OOBQuery(self, address):
        pass
            
    def Optimise(self):
        pass
        
class driverfactory:
    def createinstance(self):
        return ardimbtcpdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)